#include "Ultrasonic.h"
#include <Servo.h>
Ultrasonic L(10, 11); // Trig - first, Echo - second
Ultrasonic R(12, 13);
Servo myservo;
int speed = 100;
int hag = 0; // счетчик линий
boolean flag = false;
#define LS A0 // левый датчик линии
#define RS A1 // правый датчик линии
#define IN1 2 // мотор 1 
#define IN2 4 // мотор 1 
#define ENA 3 // мотор 1 // управление скоростью мотора 1
#define IN3 5 // мотор 2 
#define IN4 7 // мотор 2 
#define ENB 6 // мотор 2 // управление скоростью мотора 2

void setup(){
  myservo.attach(8);
  pinMode(IN1,OUTPUT);
  pinMode(IN2,OUTPUT);
  pinMode(IN3,OUTPUT);
  pinMode(IN4,OUTPUT);
  pinMode(ENA,OUTPUT);
  pinMode(ENB,OUTPUT);
  pinMode(LS,INPUT);
  pinMode(RS,INPUT);
  digitalWrite(IN1, 1); 
  digitalWrite(IN2, 0);
  digitalWrite(IN3, 1);
  digitalWrite(IN4, 0); 
  Serial.begin(9600);
}
void loop(){
  if (digitalRead(A0) == 0 && flag == false) {
    hag=++hag;
    flag = true;}
  if (digitalRead(A0)== 1) {
    flag = false;}
  Serial.println(hag);
  /*if (hag <=2)
  {speed = 150;}
  if (hag == 4)
  {analogWrite(ENA, 100);analogWrite(ENB, 100);  // скорость на камнях
  delay(3000); // время прохождения камней
  hag = 6;}
  if (hag == 6)
  {speed = 150;}
  if (hag == 12)
  {speed = 100;}*/
  if (hag == 5)
  {analogWrite(ENA, 0);analogWrite(ENB, 0);
  delay(5000);
  hag = 0;}
  float d_L = L.Ranging(CM);     // get distance
  float d_R = R.Ranging(CM);     // get distance
  int lsstatus = digitalRead(LS);
  int rsstatus = digitalRead(RS);
  /*Serial.print(d_L);
  Serial.println("cml, ");
  Serial.print(d_R);
  Serial.println("cmr, ");
  delay(500);*/
  int var = (d_L - d_R);
  //Serial.println(var);
  if ((-12<=var)&&(var<=12)) // движение прямо
    {myservo.write(90);
    analogWrite(ENA, speed);analogWrite(ENB, speed);}
  if (var > 11)               // поворот налево
    {myservo.write(60); 
    analogWrite(ENA, speed);analogWrite(ENB, speed);}
  if (var < -11)              // поворот направо
    {myservo.write(120); 
    analogWrite(ENA, speed);analogWrite(ENB, speed);}
}